/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PFIS                                                     */
/* Tabela : PARAMFISCAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 15/09/2004 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PFIS
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMFISCAL FOR EACH ROW

BEGIN
    IF INSERTING THEN
       :NEW.DTULTATUPFIS := SYSDATE;
    END IF;
    IF UPDATING THEN
       :NEW.DTULTATUPFIS := SYSDATE;
    END IF;
    IF DELETING THEN
       INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                        VALUES ('PARAMFISCAL', '', 'CDPARFISCAL='||:OLD.CDPARFISCAL||';', SYSDATE);
    END IF;
END;
/

ALTER TABLE PARAMFISCAL MODIFY DTULTATUPFIS DEFAULT SYSDATE
/
