create or replace PROCEDURE ATUALIZA_PARAMFILIAL_PDR(
P_CDFILIAL FILIAL.CDFILIAL%TYPE
)
AS
   V_UPDATE_TEXT             VARCHAR2(10000);
   V_INSERT_TEXT             VARCHAR2(10000);
   V_CDFILIAL_PADRAO         FILIAL.CDFILIAL%TYPE;
   V_DTPROCESSA              PARAMFILIAL.DTPROCESSA%TYPE;
   V_DSPARAMFATFI            PARAMFILIAL.DSPARAMFATFI%TYPE;
   V_CDALMOXARIFE            ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDFILIAL_ATUAL_ALMOX    FILIAL.CDFILIAL%TYPE;
   V_CDFILIAL_ATUAL_LOCALEST FILIAL.CDFILIAL%TYPE;
   V_CDALMOX_PADR            ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_CDLOCALEST_PADR         LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_CDSERVBAIESTCEG         VARCHAR2(10);
   V_CDSERVFILIAL            VARCHAR2(10);
BEGIN
   SELECT MAX(CDFILIPADRAO)
     INTO V_CDFILIAL_PADRAO
    FROM PARAMGERAL;


  /*vERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF V_CDFILIAL_PADRAO IS NOT NULL THEN

      SELECT MAX(CDSERVBAIESTCEG)
      INTO V_CDSERVBAIESTCEG
      FROM PARAMFILIAL
      WHERE CDFILIAL = V_CDFILIAL_PADRAO;

      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO
        DA TABELA 'PARAMFILIAL'*/
      FOR C_INSPARAM IN(SELECT CDFILIAL
                          FROM PARAMFILIPADR
                         WHERE IDTABPARAMFILI = 'S'
                           AND NMTABPARAMFILI = 'PARAMFILIAL'
                           AND CDFILIAL <> V_CDFILIAL_PADRAO
                           AND CDFILIAL = NVL(P_CDFILIAL, CDFILIAL))LOOP
         V_CDSERVFILIAL := '';
         SELECT MAX(CDSERVFILI)
         INTO V_CDSERVFILIAL
         FROM SERVICO
         WHERE CDFILIAL = C_INSPARAM.CDFILIAL
           AND CDSERVFILI = V_CDSERVBAIESTCEG;

         V_UPDATE_TEXT := 'INSERT INTO PARAMFILIAL (';
         V_INSERT_TEXT := '(SELECT ' ;
         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PARAMFILIAL'*/
         FOR C_CAMPO IN (SELECT COLUMN_NAME
                           FROM USER_TAB_COLUMNS
                          WHERE TABLE_NAME = 'PARAMFILIAL') LOOP

            IF NOT (C_CAMPO.COLUMN_NAME IN ('DTPROCESSA', 'DSPARAMFATFI',
                                            'CDFILIAL', 'CDALMOXARIFE', 'CDLOCALESTOQ')) THEN
               IF V_CDSERVBAIESTCEG IS NULL THEN
                  V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                  V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
               ELSE
                  IF NOT (C_CAMPO.COLUMN_NAME IN ('CDSERVBAIESTCEG')) THEN
                     V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                     V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                  ELSE
                     IF NOT V_CDSERVFILIAL IS NULL THEN
                        V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                        V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
        /*SALVA A DATA DE PROCESSAMENTO E O CAMPO DSPARAMFATI
          QUE NAOSAO ATUALIZADOS PELA PADRAO*/
         SELECT DTPROCESSA, DSPARAMFATFI
           INTO V_DTPROCESSA, V_DSPARAMFATFI
           FROM PARAMFILIAL
          WHERE CDFILIAL = C_INSPARAM.CDFILIAL;
         /*VERIFICA SE O ALMOXARIFADO PADRAO DA FILIAL PADRAO EXISTE NA
           FILIAL QUE SERA PARAMETRIZADA */
         BEGIN  
            SELECT PF.CDALMOXARIFE
              INTO V_CDALMOX_PADR
              FROM PARAMFILIAL PF, ALMOXARIFADO AL
             WHERE PF.CDFILIAL     = V_CDFILIAL_PADRAO
               AND AL.CDFILIAL     = C_INSPARAM.CDFILIAL
               AND PF.CDALMOXARIFE = AL.CDALMOXARIFE ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDALMOX_PADR := NULL;
         END;
          /*SE NAO EXISTIR... */
         IF V_CDALMOX_PADR IS NULL THEN
            /*VERIFICA  SE A FILIAL A SER PARAMETRIZADA
              UTILIZA A PARAMETRIZAO DA TABELA 'ALMOXARIFADO'*/      
            BEGIN
               SELECT CDFILIAL
                 INTO V_CDFILIAL_ATUAL_ALMOX
                 FROM PARAMFILIPADR
                WHERE IDTABPARAMFILI = 'S'
                  AND NMTABPARAMFILI = 'ALMOXARIFADO'
                  AND CDFILIAL = C_INSPARAM.CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDFILIAL_ATUAL_ALMOX := NULL;
            END;
            /* SE UTILIZAR ATUALIZAO CHAMA A PROCEDURE DE ATUALIZAO
              DOS PARAMETROS DA TABELA 'ALMOXARIFADO'*/   
            IF (V_CDFILIAL_ATUAL_ALMOX IS NOT NULL) THEN
               ATUALIZA_ALMOXARIFADO_PDR(C_INSPARAM.CDFILIAL, NULL);
            END IF;
         END IF;
         /*VERIFICA SE O LOCAL PADRAO DA FILIAL PADRAO EXISTE NA
           FILIAL QUE SERA PARAMETRIZADA */ 
         BEGIN  
            SELECT PF.CDLOCALESTOQ
              INTO V_CDLOCALEST_PADR
              FROM PARAMFILIAL PF, LOCALESTOQUE LE
             WHERE PF.CDFILIAL     = V_CDFILIAL_PADRAO
               AND LE.CDFILIAL     = C_INSPARAM.CDFILIAL
               AND PF.CDALMOXARIFE = LE.CDALMOXARIFE
               AND PF.CDLOCALESTOQ = LE.CDLOCALESTOQ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDLOCALEST_PADR := NULL;
         END;
          /*SE NAO EXISTIR... */
         IF V_CDLOCALEST_PADR IS NULL THEN
            /*VERIFICA  SE A FILIAL A SER PARAMETRIZADA
              UTILIZA A PARAMETRIZAO DA TABELA 'LOCALESTOQUE'*/      
            BEGIN
               SELECT CDFILIAL
                 INTO V_CDFILIAL_ATUAL_LOCALEST
                 FROM PARAMFILIPADR
                WHERE IDTABPARAMFILI = 'S'
                  AND NMTABPARAMFILI = 'LOCALESTOQUE'
                  AND CDFILIAL = C_INSPARAM.CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDFILIAL_ATUAL_LOCALEST := NULL;
            END;
            /* SE UTILIZAR ATUALIZAO CHAMA A PROCEDURE DE ATUALIZAO
              DOS PARAMETROS DA TABELA 'LOCALESTOQUE'*/   
            IF (V_CDFILIAL_ATUAL_LOCALEST IS NOT NULL) THEN
               ATUALIZA_LOCALESTOQ_PDR(C_INSPARAM.CDFILIAL, NULL, NULL);
            END IF;
         END IF;
         /*DELETA A OS PARAMETROS DA FILIAL
            QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PARAMFILIAL PF
          WHERE CDFILIAL = C_INSPARAM.CDFILIAL;
         V_UPDATE_TEXT := V_UPDATE_TEXT||'CDFILIAL, DTPROCESSA, CDALMOXARIFE, CDLOCALESTOQ, DSPARAMFATFI) ';
         V_INSERT_TEXT := V_INSERT_TEXT||''''||C_INSPARAM.CDFILIAL||''''||', ';
         IF V_DTPROCESSA IS NULL THEN
            V_INSERT_TEXT := V_INSERT_TEXT||'NULL, ';
         ELSE
            V_INSERT_TEXT := V_INSERT_TEXT||''''||V_DTPROCESSA||''''||', ';
         END IF;
         IF (V_CDALMOX_PADR IS NULL) AND
            (V_CDFILIAL_ATUAL_ALMOX IS NULL) THEN
            V_INSERT_TEXT := V_INSERT_TEXT||'NULL, ';
         ELSE
            V_INSERT_TEXT := V_INSERT_TEXT||'CDALMOXARIFE, ';
         END IF;
         IF (V_CDLOCALEST_PADR IS NULL) AND
            (V_CDFILIAL_ATUAL_LOCALEST IS NULL) THEN
            V_INSERT_TEXT := V_INSERT_TEXT||'NULL, ';
         ELSE
            V_INSERT_TEXT := V_INSERT_TEXT||'CDLOCALESTOQ, ';
         END IF;
         IF V_DSPARAMFATFI IS NULL THEN
            V_INSERT_TEXT := V_INSERT_TEXT||'NULL ';
         ELSE
            V_INSERT_TEXT := V_INSERT_TEXT||''''||V_DSPARAMFATFI||''''||' ';
         END IF;
         V_INSERT_TEXT := V_INSERT_TEXT ||'FROM PARAMFILIAL ';
         V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE CDFILIAL = '||''''||V_CDFILIAL_PADRAO||''''||') ';
         V_UPDATE_TEXT := V_UPDATE_TEXT || V_INSERT_TEXT;
         execute immediate V_UPDATE_TEXT;
      END LOOP;
      COMMIT;
   END IF;   
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_PARAMFILIAL_PDR','5.07.012'); END;
/

